using System;
using System.Collections;
using System.Configuration;
using System.Data.SqlClient;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;


namespace Telerik.Web.Examples.Controls.Integration.GridAndSplitterResizing
{
	/// <summary>
	/// Summary description for DefaultCS.
	/// </summary>
    public partial class DefaultCS : System.Web.UI.Page
	{
        private void Page_Load(object sender, System.EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                //Set initial value of the PageSize property.
                RadGrid1.PageSize = 10;
                RadGrid2.PageSize = 10;
            }
        }

        protected void RadAjaxManager1_AjaxRequest(object sender, Telerik.Web.UI.AjaxRequestEventArgs e)
        {
            switch (e.Argument.ToString())
            {
                case "PageSizeChanged":
                    int grid1Rows = (Int32.Parse(this.grid1Pane.Height.Value.ToString()) - 60) / 23;
                    if (grid1Rows >= 1)
                    {
                        RadGrid1.PageSize = grid1Rows;

                        // Check whether the CurrentPageIndex is correct.
                        if (Session["itemsCountGrid1"] != null)
                        {
                            int itemsCount = (int)Session["itemsCountGrid1"];
                            int pageCount = (int)Math.Ceiling(((double)itemsCount / grid1Rows));
                            if (RadGrid1.MasterTableView.CurrentPageIndex > pageCount - 1)
                            {
                                RadGrid1.MasterTableView.CurrentPageIndex = pageCount - 1;
                            }
                        }

                        RadGrid1.Rebind();
                    }

                    int grid2Rows = (Int32.Parse(this.grid2Pane.Height.Value.ToString()) - 60) / 23;
                    if (grid2Rows >= 1)
                    {
                        RadGrid2.PageSize = grid2Rows;

                        // Check whether the CurrentPageIndex is correct.
                        if (Session["itemsCountGrid2"] != null)
                        {
                            int itemsCount = (int)Session["itemsCountGrid2"];
                            int pageCount = (int)Math.Ceiling(((double)itemsCount / grid2Rows));
                            if (RadGrid2.MasterTableView.CurrentPageIndex > pageCount - 1)
                            {
                                RadGrid2.MasterTableView.CurrentPageIndex = pageCount - 1;
                            }
                        }

                        RadGrid2.Rebind();
                    }
                    break;
            }
        }

        public string RadGrid1PanelClientID;
        public string RadGrid2PanelClientID;       


        protected void RadAjaxManager1_AjaxSettingCreated(object sender, AjaxSettingCreatedEventArgs e)
        {
            if (e.Initiator.ID == "RadGrid1")
            {
                this.RadGrid1PanelClientID = e.UpdatePanel.ClientID;
            }
            if (e.Initiator.ID == "RadGrid2")
            {
                this.RadGrid2PanelClientID = e.UpdatePanel.ClientID;
            }     
        }

        private void RadGrid1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            String ConnString = ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString;
            SqlConnection conn = new SqlConnection(ConnString);
            SqlDataAdapter adapter = new SqlDataAdapter();
            adapter.SelectCommand = new SqlCommand("SELECT CustomerID, CompanyName, ContactName, ContactTitle FROM Customers", conn);

            DataTable myDataTable = new DataTable();

            conn.Open();
            try
            {
                adapter.Fill(myDataTable);
            }
            finally
            {
                conn.Close();
            }

            Session["itemsCountGrid1"] = myDataTable.DefaultView.Count;

            RadGrid1.DataSource = myDataTable;
        }

        private void RadGrid2_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            String ConnString = ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString;
            SqlConnection conn = new SqlConnection(ConnString);
            SqlDataAdapter adapter = new SqlDataAdapter();
            adapter.SelectCommand = new SqlCommand("SELECT CustomerID, CompanyName, ContactName, ContactTitle FROM Customers", conn);

            DataTable myDataTable = new DataTable();

            conn.Open();
            try
            {
                adapter.Fill(myDataTable);
            }
            finally
            {
                conn.Close();
            }

            Session["itemsCountGrid2"] = myDataTable.DefaultView.Count;

            RadGrid2.DataSource = myDataTable;
        }

        #region Web Form Designer generated code
        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit(e);
        }

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.RadGrid1.NeedDataSource += new Telerik.Web.UI.GridNeedDataSourceEventHandler(this.RadGrid1_NeedDataSource);
            this.RadGrid2.NeedDataSource += new Telerik.Web.UI.GridNeedDataSourceEventHandler(this.RadGrid2_NeedDataSource);
        }
        #endregion
}
}
